/****************************************************************************
 * Grafik-LCD Treiber mit VRAM.
 *
 * (C) Andreas Kaiser 2008.
 *
 * Die Software darf frei kopiert und verndert werden, solange sie
 * nicht ohne meine ausdrckliche Erlaubnis fr kommerzielle Zwecke
 * eingesetzt wird.
 ****************************************************************************/

#ifndef __GRAPH_H
#define __GRAPH_H

#define G_ROWS		LCD_ROWS
#define G_COLS		LCD_COLS

typedef lcd_row_t	g_y;
typedef lcd_col_t	g_x;

void		g_clear (void);

typedef enum { G_Clear=0, G_Set=1, G_Invert=2, G_Replace=0xFF } g_op;

bool		g_dot   (g_x x, g_y y, g_op op);
bool		g_hline (g_x x0, g_x x1, g_y y,  g_op op);
bool		g_vline (g_x x,  g_y y0, g_y y1, g_op op);
bool		g_line  (g_x x0, g_y y0, g_x x1, g_y y1, g_op op);
bool		g_fill  (g_x x0, g_y y0, g_x x1, g_y y1, g_op op);
bool		g_data  (g_x x, g_y y, g_op op, uint8_t data);

bool		g_hardfont (uint8_t width, uint8_t height);		// set ROM font
bool		g_softfont (uint8_t width, uint8_t height);		// set RAM font
bool		g_softchar (uint8_t ch, uint8_t off, uint8_t data);	// softfont character

bool		g_gpos (g_x x, g_y y);
bool		g_gchar (uint8_t ch, g_op op, int8_t angle);	// angle=-90,-45,0,45,90
void		g_gtext (const char *s, g_op op, int8_t angle);
void		g_gtext_p (const prog_char *s, g_op op, int8_t angle);
#define		g_gtext_P(s,op,angle) g_gtext_p(PSTR(s), op, angle)

bool		g_cpos (uint8_t ccol, uint8_t crow);
void		g_char (uint8_t ch);
void		g_text (const char *s);
void		g_text_p (const prog_char *s);
#define		g_text_P(s) g_text_p(PSTR(s))

#endif //__GRAPH_H
